import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import de.voidplus.leapmotion.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class leapMultiDisplays extends PApplet {



LeapMotion leap;

PVector handRight;
int displayCount = 0;
int totalDisplays = 2;
float reactorScaler = 0;
Display display;
Boolean changeScreen = false;

public void setup(){
    size(displayWidth, displayHeight);
    background(255);
    leap = new LeapMotion(this).withGestures("swipe"); // Leap detects only swipe gestures.
    handRight = new PVector(0,0);
    display = new Display(displayCount);
}

public void draw(){
  background(255);
  getHandPositions();
  display.draw(handRight, reactorScaler);
  if (changeScreen) {
        display = new Display(displayCount);
        changeScreen = false;
  }
}


public void getHandPositions() {
  for(Hand hand : leap.getHands()){

    // ----- Variables -----
    PVector hand_position    = hand.getPosition();
    boolean hand_is_left     = hand.isLeft();
    boolean hand_is_right    = hand.isRight();
    
   if(hand_is_left) {
    reactorScaler = map(hand_position.y, 650, 0, 0.001f, 0.01f); 
    } 
  if(hand_is_right) {
    handRight = hand_position;
    } 
   }
}

// ----- SWIPE GESTURE -----
public void leapOnSwipeGesture(SwipeGesture g, int state){

          PVector position_start = g.getStartPosition();
          PVector position = g.getPosition();

    switch(state){
        case 1: // Start
            break;
        case 2: // Update
            break;
        case 3: // Stop
            changeScreen = true;
            position.sub(position_start);
            position.normalize();

            if(position.x >= 0) {
              displayCount = (displayCount+1)%totalDisplays;
            } else {
              displayCount = (displayCount-1+totalDisplays)%totalDisplays;
            }
             println("swipe "+displayCount);
             break;
        }
   } 
   


class Display { 
    int _displayNumber = 0;
    // drawB
    VisualA visA;
    VisualB visB;

    Display(int displayNumber) {
              _displayNumber =  displayNumber;
               visA = new VisualA();
               visB = new VisualB();
    }

    public void draw(PVector reactor, float scaler) {

    switch (_displayNumber) {
      case 0: 
      visA.draw(reactor,scaler);
      break;
      case 1: 
      visB.draw(reactor,scaler);
       break;
       default :
      visA.draw(reactor,scaler);
       break;  
      }
    }
}
class VisualA {
  int shapeWidth = 60; 
  int shapeHeight = 60;  
  int gridWidth; 
  int gridHeight; 

VisualA() {
          gridWidth = width/shapeWidth+1; 
          gridHeight = height/shapeHeight+1;
}

public void draw(PVector _reactorPosition, float _reactorScaler) {
stroke(0); 
  background(255);
  _reactorScaler/=5; 
    for(int i = 0; i<gridWidth; i++ ) {
        for(int j = 0; j<gridHeight; j++ ) {
            float posX =  i*shapeWidth;
            float posY =  j*shapeHeight;
            float reactorDistance = sqrt((_reactorPosition.x-posX)*(_reactorPosition.x-posX)+(_reactorPosition.y-posY)*(_reactorPosition.y-posY)); ///or user dist(point1.x, point1.y, point2.x, point2.y);
            float scaler = reactorDistance*_reactorScaler;
            noFill();
            ellipse(posX, posY, shapeWidth*scaler, shapeHeight*scaler);
        };
    };
}
}
class VisualB {
int shapeWidth = 20; 
  int shapeHeight = 20;  
  int gridWidth; 
  int gridHeight; 
VisualB() {
        gridWidth = width/shapeWidth+1; 
        gridHeight = height/shapeHeight+1;
}

public void draw(PVector _reactorPosition, float _reactorScaler) {
    stroke(0); 
      background(255);
       println(_reactorScaler*2);
             for (int i = 0; i<gridWidth; i++ ) {
                beginShape();
                for (int j = 0; j<gridHeight; j++ ) {  
                  float scaler = dist(_reactorPosition.x, _reactorPosition.y, shapeWidth*i, shapeHeight*j)*_reactorScaler;
                  vertex(shapeWidth*i+(j%2*scaler), shapeHeight*j+(i%2*scaler)); 
                }
                endShape();  
              }; 
              
                for (int j = 0; j<gridHeight; j++ ) {   
                   beginShape();
                for (int i = 0; i<gridWidth; i++ ) {
                float scaler = dist(_reactorPosition.x, _reactorPosition.y, shapeWidth*i, shapeHeight*j)*reactorScaler;
                 vertex(shapeWidth*i+(j%2*scaler), shapeHeight*j+(i%2*scaler)); 
                }
                endShape();  
              }; 

    }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "leapMultiDisplays" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
