import de.voidplus.leapmotion.*;

LeapMotion leap;

PVector handRight;
int displayCount = 0;
int totalDisplays = 2;
float reactorScaler = 0;
Display display;
Boolean changeScreen = false;
Boolean mouseMode = true;
PVector mouse;

void setup(){
    size(displayWidth, displayHeight);
    background(255);
    leap = new LeapMotion(this).withGestures("swipe"); // Leap detects only swipe gestures.
    handRight = new PVector(0,0);
    display = new Display(displayCount);
    mouse = new PVector(0,0);
}

void draw(){
  background(255);
  
  if (mouseMode) {
    mouse.x = mouseX;
    mouse.y = mouseY;
    display.draw(mouse, reactorScaler);
  } else {
    getHandPositions();
    display.draw(handRight, reactorScaler);
  }

  if (changeScreen) {
        display = new Display(displayCount);
        changeScreen = false;
  }
}


void getHandPositions() {
  for(Hand hand : leap.getHands()){

    // ----- Variables -----
    PVector hand_position    = hand.getPosition();
    boolean hand_is_left     = hand.isLeft();
    boolean hand_is_right    = hand.isRight();
    
   if(hand_is_left) {
    reactorScaler = map(hand_position.y, 650, 0, 0.001, 0.01); 
    } 
  if(hand_is_right) {
    handRight = hand_position;
    } 
   }
}

// ----- SWIPE GESTURE -----
void leapOnSwipeGesture(SwipeGesture g, int state){

          PVector position_start = g.getStartPosition();
          PVector position = g.getPosition();

    switch(state){
        case 1: // Start
            break;
        case 2: // Update
            break;
        case 3: // Stop
            changeScreen = true;
            position.sub(position_start);
            position.normalize();

            if(position.x >= 0) {
              displayCount = (displayCount+1)%totalDisplays;
            } else {
              displayCount = (displayCount-1+totalDisplays)%totalDisplays;
            }
             println("swipe "+displayCount);
             break;
        }
   } 
   
// use non leap inputs 

void leapOnConnect(){
     mouseMode = false;
}

void leapOnDisconnect(){
    mouseMode = true;
}

void keyPressed() {
    switch(key) {
    case('1'): displayCount = 0; changeScreen = true; break;
    case('2'): displayCount = 1; changeScreen = true; break;
    case('3'): displayCount = 2; changeScreen = true; break;
    case('4'): displayCount = 3; changeScreen = true; break;
    case('5'): displayCount = 4; changeScreen = true; break;
    case('6'): displayCount = 5; changeScreen = true; break;
    case('7'): displayCount = 6; changeScreen = true; break;
    default : break;  
  }
  if (key == 'a') {
    reactorScaler+= .001;
  } else {
    reactorScaler-= .001;
  }
}




